#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"
#include "font.h"

#include "classes.h"

char extern *sprite_x;

void Statusbar::tonumber (char *string, long x)
{
 int i,j;
 long t;

 for (i=0;i<10; i++)
  string[i]=0;

 j=0;
 for (t=100000; t>0; t/=10)
 {
  string[j]='0'+x/t;
  x=x%t;
  j++;
 }
}

Statusbar::Statusbar(unsigned scrof)
{
 score[0]=score[1]=0;
 lives[0]=lives[1]=3;
 topscore=1000;
 screen=scrof;
}

Statusbar::~Statusbar()
{
}

void Statusbar::Update()
{
 char buffer[100];
 unsigned scrof = screen+80*2;

 paint(39,0,262,8,scrof,0);

 sprintf(buffer,"%d",lives[0]);
 aprint(41,0,21,screen,buffer);
 aprint(52,0,21,screen,"MARIO:");
 tonumber(buffer,score[0]);
 aprint(88,0,21,screen,buffer);

 sprintf(buffer,"%d",lives[1]);
 aprint(191,0,12,screen,buffer);
 aprint(202,0,12,screen,"LUIGI:");
 tonumber(buffer,score[1]);
 aprint(230,0,12,screen,buffer);


 tonumber(buffer,topscore);
 aprint(128,0,28,screen,"TOP:");
 aprint(155,0,28,screen,buffer);
}


void Statusbar::UpdateScore(unsigned player)
{
 char buffer[100];
 unsigned scrof = screen+80*2;

 if (!player)
 {
  paint(88,0,125,8,scrof,0);

  tonumber(buffer,score[0]);
  aprint(88,0,21,screen,buffer);
 }
 else
 {
  paint (230,0,260,8,scrof,0);
  tonumber(buffer,score[1]);
  aprint(230,0,12,screen,buffer);
 }

 if (score[player]>topscore)
 {
  paint(155,0,188,8,scrof,0);
  topscore=score[player];
  tonumber(buffer,topscore);
  aprint(155,0,28,screen,buffer);
 }
}

void Statusbar::UpdateLives(unsigned player)
{
 char buffer[100];
 unsigned scrof = screen+80*2;

 if (!player)
 {
  paint(41,0,48,8,scrof,0);
  sprintf(buffer,"%d",lives[0]);
  aprint(41,0,21,screen,buffer);
 }
 else
 {
  paint(191,0,199,8,scrof,0);
  sprintf(buffer,"%d",lives[1]);
  aprint(191,0,12,screen,buffer);
 }
}

void Statusbar::UpdateTop()
{
  char buffer[20];

  paint(155,0,188,8,screen,0);
  tonumber(buffer,topscore);
  aprint(155,0,28,screen,buffer);
}

