/*************************** CLASSES.CPP **********************************/

#include <stdlib.h>
#include "modex.h"
#include "classes.h"

unsigned extern cmonster;

Statusbar extern Status;

CObject extern *first;


CObject::CObject(int sx, int sy, int sdir)
{
 x=sx;
 y=sy;
 dir=sdir;
 anim=0;
 status=1;
 kpos=0; jump_power=0; speed=0; score=0; timer=0;
 fall=0; identity=0; stimer=0; dir=0; status=0;
}

CObject::CObject()
{
 anim=0;
 status=1;
}

CObject::~CObject()
{
}

void CObject::Move()
{
}

void CObject::Draw(int page)
{
}

void inline CObject::Collision()
{
 CObject *trace;
 int rx,ry,tx,ty;

 if (!stimer)
 {
  tx=x/3;
  ty=y;

  trace=first;
  while (trace)
  {
   if (trace->identity!=6)
   {
    if (trace->status>0 && !trace->stimer &&      //not this one and not dead?
	trace!=this)
    {
     trace->GetPos(&rx,&ry);                      //Pos. abfragen

     if (abs(ry-ty)<6 && tx>=rx-16 && tx<=rx+16)  //Ineinander-Kollision
     {
      if (trace->identity==0)                      // m. Mario/Luigi?
      {
       trace->Kill(-speed,0);
       timer=0;
       status=5;
      }
      else
      {
       if (myrand()&1)
	x+=speed;
       else
	x-=speed;
      }
     }
    else
     if (rx+18>=tx && rx+14<=tx)                  //Kollision links
     {
      if (trace->identity==0 && abs(ry-ty)<6)     //mit Mario
      {
	trace->Kill(-speed,0);
	timer=0;
	status=5;
      }
      else
      if (dir==0 && abs(ry-ty)<12)               // mit (langsamen) Vieh
       Turn();
     }
     else
     if (tx+18>=rx && tx+14<=rx)                 //Kollision rechts
     {
      if (trace->identity==0 && abs(ry-ty)<6)    //mit Mario
      {
	trace->Kill(-speed,0);
	status=5;
	timer=0;
      }
      else
      if (dir==1 && abs(ry-ty)<12)
       Turn();
     }
    }
   }
   trace=trace->next;
  }
 }
}

void CObject::Kicked(int pos)
{
}

void inline CObject::Kick(int kx, int ky, CPlayer *who)
{
 int rx=x/3;
 if (status && !stimer && kx>=rx-20 && kx<=rx+20 && ky>y+21 && ky<y+29)
 {
  if (identity == 1 || identity == 5)
  {
   Status.score[who->nr]+=score;
   Status.UpdateScore(who->nr);
  }
  Kicked((rx-kx)*2/3);
 }
}

void CObject::Kill(int dir)
{
}

void CObject::Kill(int dir, int type)
{
}

void inline CObject::Turn()
{
 if (dir)
  dir=0;
 else
  dir=1;
}

void inline CObject::Destroy()
{
 CObject *buffer;                               ///// Mnze zuf. erzeugen
 if (myrand()&1)                                   //
  buffer=new CCoin(3,3,1,myrandom(600)+250);       //
 else                                              //
  buffer=new CCoin(280,3,0,myrandom(600)+250);     //
						/////

 cmonster--;                                       // Anz. Monster Dekr.

 if (first==this)                               ///// Falls 1. Element d.
 {                                                 // Liste
  next->prev=buffer;                               //
  buffer->prev=NULL;                               //
  buffer->next=first->next;                        //
  first=buffer;                                    //
 }                                              /////
 else
 {                                              ///// Mitte aus der Liste
  buffer->next=next;                               // lschen
  buffer->prev=prev;                               //
  prev->next=buffer;                               //
 }                                                 //
 if (next)                                         //
  next->prev=buffer;                               //
						   //
}                                               /////

void CObject::SetMaxSpeed()
{
}
