#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"
#include "CSound.h"

#include "classes.h"

extern unsigned char far *sprites;
extern unsigned char far *msprites;
CObject extern *first;

byte danim[]={63,50,64,50};
byte const timg[]={23,24,26,25,25};

CRobot::CRobot(int nx, int ny,int nd,unsigned delay)
{
 status=0;
 score=400;
 //lifetime=0;
 identity=3;
 x=nx*3; y=ny; dir=nd;
 stimer=delay; timer=0;
 speed=1; fall=0; anim=19;
 colors[0]=23; colors[1]=128; colors[2]=132;
}

void CRobot::Draw(int page)
{
 if (!stimer)
 {
  if (status>=5)    //Beien, Umdrehen -> Aunahme
  {
   putmcsprite(x/3,y,page,colors[(speed-1)>>1],sprites+514*anim);
   return;
  }

  if (status==1 || status==5)
  {
   if (!dir)
   {
    if (speed&1)
     putmcsprite(x/3,y,page,colors[(speed-1)>>1],sprites+514*anim);
    else
     putmcsprite(x/3,y,page,colors[(speed-1)>>1],sprites+514*(anim+2));
   }
   else
   {
    if (speed&1)
     putmcsprite(x/3,y,page,colors[(speed-1)>>1],msprites+514*anim);
    else
     putmcsprite(x/3,y,page,colors[(speed-1)>>1],msprites+514*(anim+2));
   }
  }
  else
  {
   if (!dir)
   {
    if (speed&1)
     putmcsprite(x/3,y,page,colors[((speed-2)>>1)],sprites+514*anim);
    else
     putmcsprite(x/3,y,page,colors[((speed-2)>>1)],sprites+514*(anim+2));
   }
   else
   {
    if (speed&1)
     putmcsprite(x/3,y,page,colors[((speed-2)>>1)],msprites+514*anim);
    else
     putmcsprite(x/3,y,page,colors[((speed-2)>>1)],msprites+514*(anim+2));
   }
  }
 }
}

void CRobot::Move()
{
 if (stimer)
 {
  stimer--;
  if (!stimer)
  {
   PlaySound(7);
   status=1;
  }
  return;
 }

 /******************************** ROBOTER luft *************************/

 if (status==1)
 {
  Collision();
  timer++;
  if (timer>=6)                                    ///// Animationsschritte
  {                                                   //
   timer=0;                                           //
   anim++;                                            //
   if (anim>=21)                                      //
    anim=19;                                          //
  }                                                /////
  if (!dir)
   x-=(((speed>>1)+1)<<1);                         ///// X-Verschiebung
  else                                                //
   x+=(((speed>>1)+1)<<1);                            //
						      //
  if (x>320*3)                                        //
  {                                                   //
   x-=320*3;                                          //
   y--;                                               //
  }                                                   //
  else                                                //
  if (x<0)                                            //
   x+=320*3;                                       /////

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)          ///// Boden unter Fen?
  {                                                   //
   fall++;                                            // Fallbeschl.
   if (fall<15)                                       // nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                        //

  if (x<=22*3 && y>165)                             ///// Tube
  {                                                    //
   stimer=70;                                          //
   x=8*3; y=3; dir=1;                                  //
  }                                                    //
  if (x>=288*3 && y>165)                               //
  {                                                    //
   stimer=70;                                          //
   x=280*3; y=3; dir=0;                                //
  }                                                 /////
 }

 /************* Roboter ist betubt bzw. wird gergert *****************/

 if (status==2)
 {
  timer++;
  if (timer<32)
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
  }                                                //////
  else
  if (timer==16 && (speed&1))                      ////// Flug n. unten
   anim=62;                                            //
						       //
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)            //
   {                                                   //
    fall++;                                            //
    if (fall<15)                                       //
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                   //
   else                                                //
    fall=0;                                         /////

						    ///// Wenn Roboter nur
  if (!(speed&1) && timer==32)                         // gergert - ende
  {                                                    //
   timer=0;                                            //
   status=1;                                           //
   return;                                             //
  }						    /////

  if (timer<800)                                   ////// Roboter erholt sich
  {                                                    // langsam...
   if (timer%70==0)                                    //
   {                                                   //
    anim++;                                            //
    if (anim>=64)                                      //
     anim=62;                                          //
   }                                                   //
  }                                                    //
  else                                                 //
  if (timer<1100)                                      //
  {                                                    //
   if (timer%28==0)                                    //
   {                                                   //
    anim++;                                            //
    if (anim>=64)                                      //
     anim=62;                                          //
   }
  }                                                    //
  else                                             //////
  {                                                         ///// wieder 100%
   anim=19;                                                    // ok!
   timer=0;                                                    //
   status=1;                                                   //
  }                                                         /////
 }
 else
 /************************* Roboter wird unsanft gewckt ****************/

 if (status==3)
 {
  Collision();
  timer++;
  if (timer<32)
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
   return;                                             //
  }                                                //////
  else
  if (timer==16)                                   ////// Flug n. unten
   anim=20;                                            //
						       //
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)            //
   {                                                   //
    fall++;                                            //
    if (fall<15)                                       //
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                /////
  if (timer==32)
  {
   timer=status=1;
   speed-=2;
  }
 }
 else
 /************************** Toter Roboter strzt ab ***********************/
 if (status==0)
 {
  timer++;
  if (timer%6==0)                                  ///// Animationsschritte
  {                                                   //
   aindex++;                                          //
   if (aindex==4)                                     //
    aindex=0;                                         //
  }                                                /////
  anim=danim[aindex];

  if (!dir)
   x-=kpos;                                        ///// X-Verschiebung
  else                                                //
   x+=kpos;                                           //
  if (x<0)                                            //
   x+=320*3;                                       /////
						      //
						   /////
   y+=timer>>3;                                       // Y-Verschiebung
   if (y>200)
   {                                               ///// Objekt entfernen
    Destroy();                                        //
    delete this;                                      //
    return;                                           //
   }                                               /////
 }
 else
 if (status==5)                                    ///// Biest beit zu
 {                                                    //
  anim=51;                                            //
  timer++;                                            //
  if (timer==25)                                      //
  {                                                   //
   status=1;                                          //
   anim=19;                                           //
    if (dir)                                          //
     dir=0;                                           //
    else                                              //
     dir=1;                                           //
  }                                                   //
 }                                                 /////
 else
 if (status==6)                                    ///// Dreht um
 {                                                    //

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)          ///// Boden unter Fen?
  {                                                   //
   fall++;                                            //  Fallbeschl.
   if (fall<15)                                       //  nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                      ////

  timer++;                                            //
  if (timer%5==0)                                     //
  {                                                   //
   aanim++;                                           //
   if (aanim>=5)                                      //
   {                                                  //
    status=1;                                         //
    anim=bkupindex;                                   //
    if (dir)                                          //
     dir=0;                                           //
    else                                              //
     dir=1;                                           //
    return;                                           //
   }                                                ////
  }
  anim=timg[aanim];
 }
}


void CRobot::Kicked(int pos)
{
 if (status==2)
 {
  status=3;
  timer=0;
  anim=63;
  jump_power=19;
 }
 else
 if (status==6)
 {
  anim=bkupindex;
  status=2;
  kpos=pos;
  timer=0;
  jump_power=23;
  if (speed<=6)
  speed++;
 }
 else
 {
  status=2;
  kpos=pos;
  timer=0;
  jump_power=23;
  if (speed<=6)
  speed++;
 }
}

void CRobot::Kill(int pos)
{
 status=0;
 kpos=(abs(pos))>>2;
 timer=4;
 if (pos<0)
  dir=1;
 else
  dir=0;
 anim=62;
 aindex=0;
 PlaySound(4);
}

void inline CRobot::Turn()
{
 status=6;
 timer=0;
 aanim=0;
 bkupindex=anim;
 anim=23;
 return;
}


