#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "midi.h"
#include "modex.h"
#include "font.h"
#include "keyboard.h"
#include "classes.h"
#include "logo.h"
#include "midi.h"
#include "CSound.h"


#define MULTICOLOR1 5
#define MULTICOLOR2 22

CObject *first=NULL, *last=NULL, *next=NULL;
int msb;

word STORMTIME;

int extern sinval[361];


unsigned page=1600;

unsigned char far *Vscreen;              //Virtueller Bildschirm
unsigned char far *sprites;
unsigned char far *msprites;
unsigned char tubel[36*23+10];
unsigned char tuber[36*23+10];
byte extern Pow_disabled[];
byte extern Pow_small[];
byte extern Pow_medium[];
byte extern Pow_max[];
word too_slow;

Statusbar Status(48000);
CPow *Pow_Button;

unsigned cmonster;

void VLoadPcx(word x, word y, char *filename);
int load_bk_pcx(word x, word y,char *filename, unsigned scrof,
		byte offset, byte palend);

void window (int x1, int y1, int x2, int y2, unsigned scrof)
{
 unsigned x;

 paint (x1,y1,x2,y2,scrof,134);
 xline (x1,x2,y1,29,scrof);
 yline (y1,y2,x1,29,scrof);
 rectangle (x1+1,y1+1,x2-1,y2-1,24,scrof);
 xline (x1+1,x2,y2,31,scrof);
 yline (y1+1,y2,x2,31,scrof);

 for (x=x1+1; x<=x2-2; x++)
  yline(y1+1,y1+5,x,24,scrof);

 fastpp(x2-2,y1+1,30,scrof);
 fastpp(x2-4,y1+1,30,scrof);
 fastpp(x2-3,y1+2,30,scrof);
 fastpp(x2-2,y1+3,30,scrof);
 fastpp(x2-4,y1+3,30,scrof);
}

void titledata()
{
 PCX d;
 int x,y,xx,yy,c;

 ///************** Bilder laden ***********/
 setmodex();
 offscreen();
 setlstart(32000);
 raster();
 loadpcx(0,0,"title.pcx",&d,0);
 raster();
 setlstart(0);
 onscreen();
 raster();
 /*********** Hintergrundfarbe 1 = 0 ****************/
 loadpcx(0,0,"spr.pcx",&d,16000);
 for (x=0; x<320; x++)
  for (y=0; y<200; y++)
  {
   c=getpixel(x,y,1);
   if (c==1) putpixel(x,y,0,1);
   if (c==MULTICOLOR1 || c==MULTICOLOR2) putpixel(x,y,1,1);
  }

 /********* Speicher reservieren, Sprites einlesen ********/

 sprites=(unsigned char far*)farmalloc(47000);
 msprites=(unsigned char far*)farmalloc(47000);
 Vscreen=(char far*)farmalloc(64320);
 if (!sprites || !msprites || !Vscreen)
 {
  settext();
  printf("Out of Memory!");
  abort();
 }

 /************** Sprites spiegeln u. capturen *****************/

 for (y=0; y<21*7; y++)
  for (x=0; x<24*13; x+=24)
   for (xx=23; xx>=0; xx--)
   {
    c=getpixel(x+xx,y,1);
    putpixel((x+23-xx),y,c,3);
   }

 getsprite(27,155,32,16,1,Pow_max);
 getsprite(79,159,32,12,1,Pow_medium);
 getsprite(123,161,32,8,1,Pow_small);
 getsprite(164,161,32,8,1,Pow_disabled);

 for (x=0; x<13; x++)
  for (y=0; y<7; y++)
   getsprite(x*24,y*21,24,21,3,msprites+((24*21)+10)*(y*13+x));

 for (x=0; x<13; x++)
  for (y=0; y<7; y++)
   getsprite(x*24,y*21,24,21,1,sprites+((24*21)+10)*(y*13+x));

 for (x=0; x<361; x++)
  sinval[x]=(int)(100.0*sin((float)x/360.0*2*M_PI));

 delay(1200);
}

void add_object(CObject *add)
{
 add->next=NULL;
 add->prev=last;

 if (!first)
  first=next=last=add;
 else
 {
  add->prev=last;
  last->next=add;
  last=add;
 }
}

void prepare_level(int l)
{
 PCX p;
 char lvl[10];
 static char       pcx_files[][14]=   {"\0","\0",
				       "screen1.pcx","back1.pcx",
				       "screen1.pcx","back1.pcx",
				       "screen2.pcx","back2.pcx",
				       "screen2.pcx","back8.pcx",
				       "screen3.pcx","back3.pcx",
				       "screen13.pcx","back9.pcx",
				       "screen4.pcx","back4.pcx",
				       "screen4.pcx","back4.pcx",
				       "screen4.pcx","back4.pcx",
				       "screen2.pcx","back6.pcx",
				       "screen2.pcx","back6.pcx",
				       "screen2.pcx","back6.pcx",
				       "screen11.pcx","back5.pcx",
				       "screen11.pcx","back5.pcx",
				       "screen11.pcx","back5.pcx"};
 if (l<16)
 {
  loadpcx(0,0,pcx_files[l<<1],&p,48000);
  VLoadPcx(0, 0, pcx_files[l<<1]);
  load_bk_pcx(0,0,pcx_files[1+(l<<1)],48000,140,248);
 }
 else
 {
  loadpcx(0,0,"screen5.pcx",&p,48000);
  VLoadPcx(0, 0, "screen5.pcx");
  load_bk_pcx(0,0,"back7.pcx",48000,140,220);
 }

 getsprite(3,3,36,23,3,tubel);
 getsprite(280,3,36,23,3,tuber);

 paint(40,192,70,200,48000,0);
 sprintf(lvl,"P %2d",l);
 aprint(45,191,133,48000,lvl);

 rgb(31,31,31,31);   //Bin zu faul um in jedem Bild die Palette anzupassen...
 rgb(128,0,0,35);
 rgb(129,0,35,0);
 rgb(130,0,0,55);
 rgb(131,37,0,0);
 rgb(132,55,0,55);
 rgb(133,62,62,62);
 rgb(134,48,48,48);

 Status.Update();
}

void add_monster(int l)
{
 /*  0 ... void,  1 ... Turtle, 2 ... Robot, 3 ... Humer, 4 ... Drop     */

 static byte const level[][12]={1,1,1,1,1,1,1,1,1,1,1,1,
				1,1,1,1,0,0,0,0,0,0,0,0,
				1,1,1,1,1,0,0,1,1,0,0,0,
				2,2,2,2,0,0,0,0,0,0,0,0,
				2,2,1,1,2,2,0,0,0,0,0,0,
				3,3,3,3,0,0,0,0,0,0,0,0,
				3,3,2,1,2,3,3,0,0,0,0,0,
				1,1,4,3,1,1,1,1,0,0,0,0,
				2,2,3,4,2,2,2,2,0,0,0,0,
				3,2,2,2,4,2,2,2,3,2,2,0,
				1,1,4,3,1,1,1,1,4,0,0,0,
				2,2,3,4,2,2,2,2,4,0,0,0,
				3,2,2,2,4,2,2,2,3,2,2,4,
				1,1,4,3,1,1,1,1,4,0,0,0,
				2,2,3,4,2,2,2,2,4,0,0,0,
				3,2,2,2,4,2,2,2,3,2,2,4,
				1,1,4,3,1,1,1,1,4,0,0,0,
				2,2,3,4,2,2,2,2,4,0,0,0,
				3,2,2,2,4,2,2,2,3,2,2,4,
				1,1,4,3,1,1,1,1,4,0,0,0,
				2,2,3,4,2,2,2,2,4,0,0,0,
				3,2,2,2,4,2,2,2,3,2,2,4};
 int i,t,d;

 t=140;

 cmonster=0;
 for (i=0; i<12; i++)
 {
  if (level[l][i] && level[l][i]<4)
   cmonster++;
  switch (level[l][i])
  {
   case 0: break;
   case 1: if (i&1)
	    add_object(new CTurtle(280,3,0,t));
	   else
	    add_object(new CTurtle(3,3,1,t));
	   break;

   case 2: if (i&1)
	    add_object(new CRobot(280,3,0,t));
	   else
	    add_object(new CRobot(3,3,1,t));
	   break;

   case 3: if (i&1)
	    add_object(new CHumer(248,3,0,t));
	   else
	    add_object(new CHumer(40,3,1,t));
	   break;

   case 4: if (i&1)
	    add_object(new CDrop(280,3,0,t));
	   else
	    add_object(new CDrop(3,3,1,t));
	   break;
  }
  t+=140;
 }
}

int game_loop()
{
 int rc;
 word i;
 word live;
 word monster;
 CObject *trace;
 clock_t start,end;

 page=1600;

 rc=0;                               ///// Adaptive Geschwindigkeitsregelung
 do                                     //
 {                                      //
  if (rc==0)                            //
   start=clock();                       //
					//
  if (rc>=24)                           // 24 Bilder
  {                                     //
   rc=0;                                //
   end=clock();                         //
   if ((int)(end-start) > 8)            // in normalerweise 1/3 sec.
    too_slow++;                         // zu langsam - Bildupdate auslassen
   else                                 //
    if ((int)(end-start) < 5)           // zu schnell - Bildupdate hinzufgen
     if (too_slow>1)                    // Sicherheitsberprfung
      too_slow--;                       //
					//
   start =clock();                      // Getestet fr 60Hz biw 72Hz!
  }                                  /////

  copyscreen(48000,page);

  if (keyboard()==1)
  {                                  /////  Escape
   settext();                           //
   restorekeyint();                     //
   farfree(sprites);                    //
   farfree(msprites);                   //
   exit(1);                          /////
  }

  for (i=0; i<too_slow; i++)          //// Objekte berechnen
  {                                     //
   rc++;                                //
   trace=first;                         //
   while(trace)                         //
   {                                    //
    trace->Move();                      //
    trace=trace->next;                  //
   }                                    //
  }                                  /////

  if (cmonster==1)                   ///// Letztes Monster mit
  {                                     // Vollgeschw. fahren
   trace=first;                         //
   while (trace)                        //
   {                                    //
    trace->SetMaxSpeed();               //
    trace=trace->next;                  //
   }                                    //
  }                                  /////

  trace=first;
  live=0;

  while(trace)                      ///// Objekte Darstellen
  {                                    //
   if (trace->identity==0)             //
    live=1;                            //
				       //
   trace->Draw(page);                  //
   trace=trace->next;                  //
  }                                 /////
  Pow_Button->Draw(page);
  putxshape (3, 3, page, tubel);
  putxshape (280, 3, page, tuber);


  setlstart(page);
  raster();
  if (page==1600)
   page=19200;
  else
   page=1600;
 }
 while(cmonster && live);

 if (cmonster)
  return 0;
 else
  return 1;
}

void cleanup()
{
 CObject *trace,*del;

 trace=first;
 while(trace)
 {
  if (trace->identity>0)
  {
   trace->Destroy();
   del=trace;
   trace=trace->next;
   delete del;
  }
  else
   trace=trace->next;
 }
 trace=first;
 while(trace->next)
  trace=trace->next;
 last=trace;
}

void start_game(int player,int level)
{
 int stat;
 Pow_Button = new CPow;

 add_object(new CPlayer(0,&kplayer2));
 if(player==2)
  add_object(new CPlayer(1,&kplayer1));

 do
 {
  offscreen();
  prepare_level(level);
  add_monster(level);
  STORMTIME = (2000/level)+myrandom(70);
  copyscreen(48000,1600);
  copyscreen(48000,19200);
  raster();
  onscreen();
  stat=game_loop();
  cleanup();

  if (stat)
  {
   window(118,71,216,107,1600);
   window(118,71,216,107,19200);
   aprint(121,78,31,1600,"CONGRATULATIONS");
   aprint(121,78,31,19200,"CONGRATULATIONS");
   aprint(133,94,31,1600,"Level Complete");
   aprint(133,94,31,19200,"Level Complete");
   delay(1200);
  }
  else
  {
   window(118,71,216,92,1600);
   window(118,71,216,92,19200);
   aprint(121,87,31,1600,"GAME OVER!");
   aprint(121,87,31,19200,"GAME OVER!");
   delay(1200);
  }
  level++;
 }while(stat);
 delete Pow_Button;
}
/*
int refresh()
{
 int i,j;
 int refresh;
 clock_t start,end;

 start=clock();
 for (i=0; i<50; i++)
 {
  copyscreen(32000,48000);
  for (j=0; j<320; j++)
   putpixel(j,0,1,3);
  for (j=0; j<20; j++)
   getpixel(j,0,0);
  raster();
 }
 end=clock();
 refresh=(int)((18.2*50)/(float)(end-start));
 return refresh;
}
*/

void select_options(int *player, int *start)
{
  PCX p;
  int ch;

  offscreen();
  raster();
  setlstart(0);
  loadpcx(0,0,"title.pcx",&p,0);
  paint(0,110,320,170,0,0);
  //load_bk_pcx(0,0,"back8.pcx",0,140,220);
  raster();
  onscreen();
  raster;

  rgb(31,31,31,31);   //Bin zu faul um in jedem Bild die Palette anzupassen...
  rgb(128,0,0,35);
  rgb(129,0,35,0);
  rgb(130,0,0,55);
  rgb(131,55,10,10);
  rgb(132,55,0,55);
  rgb(133,62,62,62);
  rgb(134,48,48,48);

  for(;;)
  {
   window(50,110,270,190,0);
   aprint(60,120,31,0,"F1");
   aprint(60,133,31,0,"F2");
   aprint(60,146,31,0,"F3");
   aprint(60,166,31,0,"F10");

   if (*player==1)
    aprint(90,120,31,0,"One Player Game");
   else
    aprint(90,120,31,0,"Two Player Game");
   aprint(90,133,31,0,"Starting Level :");
   aprint(90,146,31,0,"START");
   aprint(90,166,31,0,"Exit to DOS");

   window(217,123,247,149,0);
   paint(220,129,245,147,0,0);

   rgb(251,35,35,35);
   rgb(252,20,20,20);
   putosprite(227,165,0,(unsigned char far*)logo);

   switch (*start)
   {
    case 1:
    case 2: putmcsprite(220,125,0,129,sprites+((24*21)+10)*13); break;
    case 3:
    case 4: putmcsprite(220,125,0,128,sprites+((24*21)+10)*21); break;
    case 5:
    case 6: putxsprite(220,125,0,sprites+((24*21)+10)*71); break;
    case 7:
    case 8:
    case 9: putxsprite(220,125,0,sprites+((24*21)+10)*27); break;
    case 10:
    case 11:
    case 12: putxsprite(221,128,0,sprites+((24*21)+10)*69); break;
   }
   ch=getch();
   if (ch==0)
   {
    ch=getch();
    switch(ch)
    {
     case 59: if (*player==1)
	       *player=2;
	      else *player=1;
	      break;
     case 60: if (*start<6)
	       *start+=2;
	      else
	       *start+=3;
	      if (*start>12)
	       *start=1;
	      break;

     case 61: return;
     case 68: *player=*start=0;
	      return;
    }
   }
  }
}

void reinit_game()
{
 CObject *trace,*next;

 trace=first;
 while(trace)
 {
  next=trace->next;
  delete trace;
  trace=next;
 }
 first = last = next = NULL;
}

void set_sounds()
{
 TON s_run={ 0,15, 0, 8,10,10, 2, 2,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0};

 setup(1,&s_run);
 setup(2,&s_run);
}

void main()
{
 int st=1,pl=2;

 CreateCSound();
 msb=detectadlib();

 /*if (sb)
  set_sounds();  */
 printf("Freier near-Speicher: %u\n",coreleft());
 printf("Freier far-Speicher: %lu\n",farcoreleft());

 randomize();
 myrandomize();

 loadfont();
 titledata();
 too_slow=1;

 do
 {
  select_options(&pl,&st);
  dark(0);
  if (pl)
  {
   setkeyint();
   start_game(pl,st);

   if (page==1600)
    dark(19200);
   else
    dark(1600);

   reinit_game();
   Status.score[0]=Status.score[1]=0;
   Status.lives[1]=Status.lives[0]=3;
   restorekeyint();
  }
 } while(pl);

 farfree(Vscreen);
 farfree(sprites);
 farfree(msprites);
 destroyfont();
 settext();
 DestroyCSound();
}

