#include <dos.h>
#include <stdio.h>
#include "modex.h"

extern char far* Vscreen;

int load_bk_pcx(word x, word y,char *filename, unsigned scrof,
		byte offset, byte palend)
{
 FILE *fl;
 PCX a;
 word j,xx,yy,px,py;
 long i;
 byte ch,ci,r,g,b,col;
 word page=scrof/16000;

 fl=fopen(filename,"rb");
 fread (&a,1,128,fl);
/*
 printf("Kennung: %X\n",a.kenn);
 printf("RLE: %u\n",a.rle);
 printf("Bits/Pixel: %u\n",a.bpp);
 printf("Koordinaten links oben: %u,%u\n",a.xlo,a.ylo);
 printf("Koordinaten rechts unten: %u,%u\n",a.xru,a.yru);
 printf("hoizontale Aufl.: %u\n",a.xdpi);
 printf("vertikale Aufl.: %u\n",a.ydpi);
 printf("Palette 16Color.: ...\n");
 printf("reserviertes Byte: %u\n",a.r);
 printf("Anzahl d. Planes: %u\n",a.planes);
 printf("Bytes/Bildzeile: %u\n",a.bpb);
 printf("Art d. Palette: %u\n",a.palette);
 printf("Reserviert: ...\n");
 */
 xx=x; yy=y;
 i=0;
 do
 {
  ch=getc(fl);
  if ((ch&(128+64))!=128+64)
  {
   if (getpixel(xx,yy,page)<=1)
    putpixel(xx,yy,ch+offset,page);

   i++;
   xx++;
   if (xx-x>=a.bpb)
   {
    xx=x;
    yy++;
   }
  }
  else
  {
   ci=getc(fl);
   for (j=1; j<=(ch&63); j++)
   {
    if (getpixel(xx,yy,page)<=1)
     putpixel(xx,yy,ci+offset,page);

    i++;
    xx++;
    if (xx-x>=a.bpb)
    {
     xx=x;
     yy++;
    }
   }
  }
 } while (i<(long)(a.yru-a.ylo+1)*(long)(a.xru-a.xlo+1));

 r=getc(fl);

 for (i=offset; i<palend; i++)
  {
   r=getc(fl)>>2;
   g=getc(fl)>>2;
   b=getc(fl)>>2;
   rgb (i,r,g,b);
  }
 fclose(fl);
}

void VPutPixel(word x, word y, unsigned char col)
{
 Vscreen[y*320+x]=col;
}

unsigned char VGetPixel(word x, word y)
{
 word f,o;

 f=FP_SEG(Vscreen); o=FP_OFF(Vscreen);
 asm {mov ax,f
      mov es,ax
      mov ax,y
      mov bx,320
      mul bx
      add ax,x
      add ax,o
      mov di,ax
      mov al,es:[di]};
 return _AL;
}

void VLoadPcx(word x, word y, char *filename)
{
 FILE *fl;
 PCX a;
 word j,xx,yy,px,py;
 long i;
 byte ch,ci,r,g,b,col;

 fl=fopen(filename,"rb");
 fread (&a,1,128,fl);
 xx=x; yy=y;
 i=0;
 do
 {
  ch=getc(fl);
  if ((ch&(128+64))!=128+64)
  {
   VPutPixel(xx,yy,ch);

   i++;
   xx++;
   if (xx-x>=a.bpb)
   {
    xx=x;
    yy++;
   }
  }
  else
  {
   ci=getc(fl);
   for (j=1; j<=(ch&63); j++)
   {
    VPutPixel(xx,yy,ci);

    i++;
    xx++;
    if (xx-x>=a.bpb)
    {
     xx=x;
     yy++;
    }
   }
  }
 } while (i<(long)(a.yru-a.ylo+1)*(long)(a.xru-a.xlo+1));

 fclose(fl);
}
