#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"
#include "CSound.h"

#include "classes.h"

extern unsigned char far *sprites;
extern unsigned char far *msprites;

CObject extern *first;

byte dhanim[]={74,54,75,54};

CHumer::CHumer(int nx, int ny,int nd,unsigned delay)
{
 status=4;
 score=500;
 //lifetime=0;
 identity=4;
 x=nx*3; y=ny; dir=nd;
 stimer=delay; timer=32;
 speed=1; fall=0; anim=70;
}

void CHumer::Draw(int page)
{
 if (!stimer)
 {
  if (!dir)
   putxsprite(x/3,y,page,sprites+514*anim);
  else
   putxsprite(x/3,y,page,msprites+514*anim);
 }
}

void CHumer::Move()
{
 if (stimer)
 {
  stimer--;
  if (!stimer)
  {
   PlaySound(7);
   status=1;
  }
  return;
 }

 /************************** Humer flattert durch die Gegend **********/

 if (status==1)
 {
  Collision();
  timer++;
  if (timer>0 && timer<32)
  {
   if (dir)
    x+=speed;
   else
    x-=speed;

   y-=(32-timer)>>4;
   if (timer%3==0)
    anim++;
   if (anim==73)
    anim=70;
  }
  else
  if (timer>=32 && timer<64)
  {
   if (dir)
    x+=speed;
   else
    x-=speed;

   y+=(timer-32)>>4;
   if (timer%3==0)
    anim++;
   if (anim==73)
    anim=70;
  }
  else
  if (timer<140)
  {
   anim=70;
   if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
    y--;
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)         ///// Boden unter Fen?
   {                                                   //
    fall++;                                            // Fallbeschl.
    if (fall<15)                                       // nhern
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                   //
   else                                                //
   {                                                   //
    anim=70;                                           //
    fall=0;                                            //
   }						    /////
  }
  else
   timer=0;

  if (x>320*3)                                       ///// X-Overflow?
  {                                                     //
   x-=320*3;                                            //
   y--;                                                 //
  }                                                     //
  else                                                  //
  {                                                     //
   if (x<0)                                             //
   {                                                    //
    x+=320*3;                                           //
    y--;                                                //
   }                                                    //
						   //////

   if (x<=22*3 && y>155)                             ///// Tube
   {                                                    //
    stimer=70;                                          //
    timer=32;                                           //
    x=40*3; y=3; dir=1;                                 //
   }                                                    //
   else                                                 //
   if (x>=288*3 && y>155)                               //
   {                                                    //
    stimer=70;                                          //
    timer=32;                                           //
    x=248*3; y=3; dir=0;                                //
   }                                                 /////
  }
 }
 else

 /******************************* Humer wird betubt **************/

 if (status==2)
 {
  timer++;
  if (timer<32)
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   anim=72;
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
  }                                                //////
  else
  if (timer==16)                                   ////// Flug n. unten
   anim=74;                                            //
						       //
   if (VGetPixel((x/3)+18-dir*12,y+20)<250)            //
   {                                                   //
    fall++;                                            //
    if (fall<15)                                       //
     y++;                                              //
    else                                               //
     y+=2;                                             //
   }                                                /////

  if (timer<800)                                   ////// Humer erholt sich
  {                                                    // langsam...
   if (timer%70==0)                                    //
   {                                                   //
    anim++;                                            //
    if (anim==75)                                      //
     anim=73;                                          //
   }                                                   //
  }                                                    //
  else                                                 //
  if (timer<1100)                                      //
  {                                                    //
   if (timer%28==0)                                    //
   {                                                   //
    anim++;                                            //
    if (anim==75)                                      //
     anim=73;                                          //
   }
  }                                                    //
  else                                             //////
  {                                                         ///// wieder 100%
   anim=70;                                                    // ok!
   timer=0;                                                    //
   status=1;                                                   //
   if (speed<3)                                                //
    speed++;                                                   //
  }                                                         /////
 }
 else
 /************************* Humer wird unsanft gewckt ****************/

 if (status==3)
 {
  Collision();
  timer++;
  {
   x+=kpos/4;                                       ///// X-Verschiebung
   if (x>320*3)                                        //
   {                                                   //
    x-=320*3;                                          //
    y--;                                               //
   }                                                   //
   else                                                //
   if (x<0)                                            //
    x+=320*3;                                       /////
  }

  if (timer<16)                                    ////// Flug nach oben
  {                                                    //
   y-=(jump_power-timer)>>3;                           //
   if (((int)jump_power-(int)timer)<=0)                //
    fall=1;                                            //
   return;                                             //
  }                                                //////
  else
  {
   status=1;
   timer=15;
  }
 }
 else
 /************************ Toter Humer strzt ab **********************/
 if (status==0)
 {
  timer++;
  if (timer%6==0)                                  ///// Animationsschritte
  {                                                   //
   aindex++;                                          //
   if (aindex==4)                                     //
    aindex=0;                                         //
  }                                                /////
  anim=dhanim[aindex];

  if (!dir)
   x-=kpos;                                        ///// X-Verschiebung
  else                                                //
   x+=kpos;                                           //
  if (x<0)                                            //
   x+=320*3;                                       /////
						      //
						   /////
   y+=timer>>3;                                       // Y-Verschiebung
   if (y>200)
   {                                               ///// Objekt entfernen
    Destroy();                                        //
    delete this;                                      //
    return;                                           //
   }                                               /////
 }
 else
 if (status==5)                                    ///// Biest beit zu
 {                                                    //
  timer++;                                            //
  if (timer==25)                                      //
  {                                                   //
   status=1;                                          //
   Turn();                                            //
  }                                                   //
 }                                                  ////

}



void CHumer::Kicked(int pos)
{
 if (status==2)
 {
  status=3;
  timer=0;
  anim=70;
  jump_power=19;
 }
 else
 {
  status=2;
  kpos=pos;
  timer=0;
  jump_power=23;
 }
}

void CHumer::Kill(int pos)
{
 status=0;
 kpos=(abs(pos))>>2;
 timer=4;
 if (pos<0)
  dir=1;
 else
  dir=0;
 anim=62;
 aindex=0;
 PlaySound(4);
}

void inline CHumer::Collision()
{
 CObject *trace;
 int rx,ry,tx,ty;

 tx=x/3;
 ty=y;

 trace=first;
 while (trace)
 {
  if (trace!=this && trace->status>0 &&        //not this one and not dead?
      !stimer && !trace->stimer)
  {
   trace->GetPos(&rx,&ry);                     //Pos. abfragen

   if (tx>=rx-16 && tx<=rx+16 && abs(ry-ty)<6) //Ineinander-Kollision
   {
    if (trace->identity==0)                    //Kollision m. Mario/Luigi?
    {
     trace->Kill(-speed,0);
     Turn();
    }
   }

   if (rx+18>=tx && rx+14<=tx)  //Kollision links
   {
    if (trace->identity==0 && abs(ry-ty)<6)     //mit Mario
    {
     trace->Kill(-speed,0);
     Turn();
    }
    else
    if (abs(ry-ty)<12 && dir==0)               // mit (langsamen) Vieh
     Turn();
   }
   else
   if (tx+18>=rx && tx+14<=rx) //Kollision rechts
   {
    if (trace->identity==0 && abs(ry-ty)<6)
    {
     trace->Kill(-speed,0);
     Turn();
    }
    else
    if (dir==1 && abs(ry-ty)<12)
     Turn();
   }
  }
  trace=trace->next;
 }
}

