#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"

#include "classes.h"

byte Pow_disabled[32*8+10];
byte Pow_small[32*8+10];
byte Pow_medium[32*12+10];
byte Pow_max[32*16+10];


CObject extern *first;

CPow::CPow()
{
 byte const col[]={28,17,16,7,20,11,12,6,0,0};
 size=3;
 status=1;
 score=0;
 memcpy(colors,col,10);
 timer=colorpt=0;
}

CPow::~CPow()
{
}

void CPow::Draw(int page)
{
 timer++;
 if (timer==70)
 {
  colorpt++;
  if (colorpt>8)
   colorpt=0;
  timer=0;
 }
 switch (size)
 {
  case 3: putmcsprite (148,138,page,colors[colorpt],Pow_max); break;
  case 2: putmcsprite (148,140,page,colors[colorpt],Pow_medium); break;
  case 1: putmcsprite (148,142,page,colors[colorpt],Pow_small); break;
  default: putmcsprite (148,142,page,colors[colorpt],Pow_disabled); break;
 }
}

void CPow::Kicked(int pos)
{
 CObject *trace;

 trace = first;
 while (trace)
 {
  if (trace->status && !trace->stimer && !trace->fall)
   trace->Kicked(0);
  trace=trace->next;
 }
 size--;
}

void CPow::Destroy()
{
}

void inline CPow::Kick(int kx, int ky, CPlayer *who)
{
 if (size && kx>=148-19 && kx<=148+32-5 && ky>142+2 && ky<142+10)
 {
  Kicked(0);
 }
}

