#include <dos.h>
#ifndef __MIDI
#define __MIDI

typedef unsigned char byte;

typedef struct {byte attack1,attack2,decay1,decay2,sustian1,sustian2;
		byte release1,release2,susts1,susts2,volume1,volume2;
		byte evenlope1, evenlope2, scaling1, scaling2;
		byte fmultiplier1,fmultiplier2,wave1,wave2,pitch1,pitch2;
		byte addsynth, feedback;} TON;

void setreg(byte reg,byte val);
int detectadlib();
void sbsound(byte voice, byte staff, byte octave);
void sbnosound(byte voice);
void setup(byte voice,TON *a);
void playakkord(byte base,char dur,byte okt);
void setf(int freq, byte voice);

#endif



